{ ---C -- FK -- 14.12.03 -- GrafTool.PAS -- UNIT Grafik Sprachbibliothek -- }

UNIT GrafTool;

INTERFACE

USES CRT,DOS,GRAPH;

{neue globale Datentypen }
TYPE Kette         = STRING[21];
     Matrix        = ARRAY[1..100] OF POINTTYPE;
     PointType3D   = RECORD
                      x,y,z : INTEGER;
                     END;
     Matrix3D      = ARRAY[1..100] OF PointType3D;

VAR  Treiber,Modus  : INTEGER;

PROCEDURE VGATreiber_Lo(Pfad:STRING);
PROCEDURE VGATreiber_Med(Pfad:STRING);
PROCEDURE VGATreiber_Hi(Pfad:STRING);
PROCEDURE SVGA_grafik_ein(modus:INTEGER; Pfad : STRING);
{Pfad: meist C:\tp\bgi, dort mu der svga256-treiber liegen,
modus: 0..320*200 , 256 Farben
       1..640*400 , 256 Farben
       2..640*480 , 256 Farben
       3..800*600 , 256 Farben
       4..1024*768, 256 Farben}
PROCEDURE InTextXY(x,y,Schrift,vg,hg:INTEGER; VAR tw:Kette);
{Aufruf z.B. mit :  InTextXY(100,100,1,2,4,Volumen)
dabei ist x,y         - Grafikcursorposition der Schrift
          Schrift     - Schriftart,
          vg,hg       - Vordergrund-,Hintergrundfarbe
          t           - Textvariable fr max. 20 Zeichen}
PROCEDURE GrafFarbe(vg,hg:INTEGER);
PROCEDURE GrafRahmen(ax,ay,bx,by,v,h:INTEGER);
PROCEDURE Schalter(ax,ay,bx,by,v,h,sf:INTEGER;txt:STRING;ein,aktiv:BOOLEAN);
PROCEDURE Panel(ax,ay,bx,by,v,h,sf:INTEGER;txt:STRING);
PROCEDURE Lade_Bild(X1,Y1:INTEGER; Bildname:STRING; Operation:WORD);
PROCEDURE Speichere_Bild(X1,Y1,X2,Y2:INTEGER; Bildname: STRING);
PROCEDURE Verschieben(x,y,Anzahl:INTEGER; VAR Figur:Matrix);
PROCEDURE Verzerren(x,y:REAL; Anzahl:INTEGER; VAR Figur:Matrix);
PROCEDURE Mittelpunkt(Radius,Winkel:INTEGER; VAR XM,YM:INTEGER);
PROCEDURE Drehen(X_Dreh,Y_Dreh,Drehwinkel:INTEGER;
                 VAR Figur: Matrix; Anzahl:INTEGER);
PROCEDURE Horiz_Spiegeln(Anzahl: INTEGER; VAR Figur: Matrix);
PROCEDURE Transforme_R3_R2(Anzahl: INTEGER; a:Matrix3D; VAR Figur:Matrix);
PROCEDURE Drehen3D(DZ:PointType3D; x,y,z: INTEGER; VAR P:PointType3D);
{Dreht einen Punkt P um ein Drehzentrum DZ um einen bestimmten Winkel x,y,z
im Gradma um die x,y,z - Achsen, und liefert die neuen Koordinaten von P
zurck.}

IMPLEMENTATION

PROCEDURE VGATreiber_LO(Pfad:STRING);
BEGIN
 treiber:=9; modus:=VGALo;
 INITGRAPH(treiber,modus,Pfad);
 IF GraphResult<>0 THEN
    BEGIN
     WRITELN('Grafik-Fehler: ',GraphErrorMsg(GraphResult));
     WRITE('Weiter mit ENTER');
     READLN;
     Halt;
    END;
END;

PROCEDURE VGATreiber_Med(Pfad:STRING);
BEGIN
 treiber:=9; modus:=VGAMed;
 INITGRAPH(treiber,modus,Pfad);
 IF GraphResult<>0 THEN
    BEGIN
     WRITELN('Grafik-Fehler: ',GraphErrorMsg(GraphResult));
     WRITE('Weiter mit ENTER');
     READLN;
     Halt;
    END;
END;

PROCEDURE VGATreiber_Hi(Pfad:STRING);
BEGIN
 treiber:=9; modus:=VGAHi;
 INITGRAPH(treiber,modus,Pfad);
 IF GraphResult<>0 THEN
    BEGIN
     WRITELN('Grafik-Fehler: ',GraphErrorMsg(GraphResult));
     WRITE('Weiter mit ENTER');
     READLN;
     Halt;
    END;
END;

PROCEDURE SVGA_grafik_ein(modus:INTEGER; Pfad : STRING);
VAR ErrorCode : WORD;
BEGIN
  treiber:=InstallUserDriver('SVGA256', nil);
  IF treiber = grError THEN Halt(1);
  InitGraph(treiber, modus, Pfad);
End;

PROCEDURE InTextXY(x,y,Schrift,vg,hg:INTEGER; VAR tw:Kette);
VAR z     : INTEGER;
    txt   : Kette;
    ztext : ARRAY[1..21] OF Kette;
    b     : CHAR;

BEGIN
 SETCOLOR(vg);
 SETTEXTSTYLE(Schrift,0,USERCHARSIZE);
 tw:=''; z:=0; txt:='_';
 OUTTEXTXY(x,y,txt);
 REPEAT
  b:=READKEY;
  IF b<>#08 THEN BEGIN
                 If z<21 THEN z:=z+1;
                 ztext[z]:=tw;
                 txt:=CONCAT(ztext[z],'_');
   SETCOLOR(hg); OUTTEXTXY(x,y,txt);
                 IF z<21 THEN tw:=CONCAT(tw,b);
                 IF b=#13 THEN BEGIN
                               IF z<21 THEN tw:=COPY(tw,1,LENGTH(tw)-1);
                               txt:=tw;
                               END
                          ELSE txt:=CONCAT(tw,'_');
   SETCOLOR(vg); OUTTEXTXY(x,y,txt);
                 END
            ELSE BEGIN
                 tw:=ztext[z];
   SETCOLOR(hg); OUTTEXTXY(x,y,txt);
                 txt:=ztext[z];
                 txt:=CONCAT(txt,'_');
   SETCOLOR(vg); OUTTEXTXY(x,y,txt);
                 IF z>1 THEN z:=z-1
                        ELSE z:=1;
                 END;
 UNTIL b=#13;
END;

PROCEDURE GrafFarbe(vg,hg : INTEGER);
BEGIN
 SETCOLOR(vg);
 SETBKCOLOR(hg);
END;

PROCEDURE GrafRahmen(ax,ay,bx,by,v,h:INTEGER);
BEGIN
 GrafFarbe(v,h);
 RECTANGLE(ax,ay,bx,by);
 RECTANGLE(ax+3,ay+3,bx-3,by-3);
END;

Procedure Schalter(ax,ay,bx,by,v,h,sf:INTEGER;txt:STRING;ein,aktiv: BOOLEAN);
VAR MerkFarbe,s,w : INTEGER;
BEGIN
 MerkFarbe:=GETCOLOR;
 SETCOLOR(v);
 RECTANGLE(ax,ay,bx,by);
 SETFILLSTYLE(1,h);
 FLOODFILL(ax+2,ay+2,v);
 SETTEXTSTYLE(2,0,0);
 SETTEXTJUSTIFY(1,1);
 IF ein THEN BEGIN s:=8 ; w:=15 END
        ELSE BEGIN s:=15; w:=8  END;
 SETCOLOR(s); LINE(ax+1,ay+1,bx-1,ay+1);LINE(ax+1,ay+1,ax+1,by-1);
 SETCOLOR(w); LINE(bx-1,ay+1,bx-1,by-1);LINE(ax+1,by-1,bx-1,by-1);
 IF aktiv THEN
    BEGIN
     SETCOLOR(sf); OUTTEXTXY((ax+bx) DIV 2,(ay+by) DIV 2,txt);
    END
          ELSE
    BEGIN
     SETCOLOR(sf+8); OUTTEXTXY((ax+bx) DIV 2,(ay+by) DIV 2,txt);
    END;
 SETCOLOR(MerkFarbe);
 SETTEXTJUSTIFY(0,0);
END;

PROCEDURE Panel(ax,ay,bx,by,v,h,sf:INTEGER;txt:STRING);
VAR Merkfarbe : INTEGER;
BEGIN
 MerkFarbe:=GETCOLOR;
 SETCOLOR(v);
 RECTANGLE(ax,ay,bx,by);
 SETFILLSTYLE(1,h);
 FLOODFILL(ax+2,ay+2,v);
 SETTEXTSTYLE(2,0,0);
 SETTEXTJUSTIFY(1,1);
 SETCOLOR(8); LINE(ax+1,ay+1,bx-1,ay+1);LINE(ax+1,ay+1,ax+1,by-1);
 SETCOLOR(15); LINE(bx-1,ay+1,bx-1,by-1);LINE(ax+1,by-1,bx-1,by-1);
 SETCOLOR(sf); OUTTEXTXY((ax+bx) DIV 2,(ay+by) DIV 2,txt);
 SETCOLOR(MerkFarbe);
 SETTEXTJUSTIFY(0,0);
END;

PROCEDURE Lade_Bild(X1,Y1: INTEGER; Bildname: STRING; Operation: WORD);
VAR p         :POINTER;
    Bilddatei :FILE;
    Groesse   :WORD;

BEGIN
  {Inhalt der Bilddatei in den Heap bertragen}
  ASSIGN(Bilddatei,Bildname);
  RESET(Bilddatei,1);
  Groesse:= FileSize(Bilddatei);
  GetMem(p,Groesse);
  BlockRead(Bilddatei,p^ ,Groesse);
  CLOSE(Bilddatei);
  {Bilddaten vom Heap in den Bildausschnitt kopieren}
  PutImage(X1,Y1,p^ ,Operation);
  FreeMem(p,Groesse)
END;

PROCEDURE Speichere_Bild(X1,Y1,X2,Y2: INTEGER; Bildname: STRING);
VAR p         :POINTER;
    Bilddatei :FILE;
    Groesse   :WORD;

BEGIN
  {Bildauschnitt in den Heap kopieren}
  Groesse:= ImageSize(X1,Y1,X2,Y2);
  GetMem(p,Groesse);
  GetImage(X1,Y1,X2,Y2,p^ );
  {Bildausschnitt in der Bilddatei speichern}
  ASSIGN(Bilddatei,Bildname);
  REWRITE(Bilddatei,Groesse);
  BlockWrite(Bilddatei,p^ ,1);
  FreeMem(p,Groesse);
  CLOSE(Bilddatei)
END;

PROCEDURE Verschieben(x,y,Anzahl: INTEGER; VAR Figur: Matrix);
VAR I: INTEGER;
BEGIN
  FOR I:= 1 TO Anzahl DO
      BEGIN
        Figur[I].X:= Figur[I].X + x;
        Figur[I].Y:= Figur[I].Y + y;
      END
END;

PROCEDURE Verzerren(x,y: REAL; Anzahl: INTEGER; VAR Figur: Matrix);
VAR I: INTEGER;
BEGIN
  FOR I:= 1 TO Anzahl DO
      BEGIN
        Figur[I].X:= ROUND(Figur[I].X * x);
        Figur[I].Y:= ROUND(Figur[I].Y * y)
      END
END;

PROCEDURE Mittelpunkt(Radius,Winkel: INTEGER; VAR XM,YM: INTEGER);
VAR Bogen: REAL;
BEGIN
   Bogen:= Winkel*PI/180;
   XM:= ROUND(Radius*COS(Bogen));
   YM:= ROUND(Radius*SIN(Bogen));
END;

PROCEDURE Drehen(X_Dreh,Y_Dreh,Drehwinkel: INTEGER;
                 VAR Figur: Matrix; Anzahl: INTEGER);
VAR Bogen,X0,Y0: REAL;
    I          : WORD;
BEGIN
  Bogen:= Drehwinkel*PI/180;
  FOR I:=1 TO Anzahl DO
      BEGIN
        X0:= COS(Bogen)*(Figur[I].X-X_Dreh)
            -SIN(Bogen)*(Figur[I].Y-Y_Dreh) + X_Dreh;
        Y0:= SIN(Bogen)*(Figur[I].X-X_Dreh)
            +COS(Bogen)*(Figur[I].Y-Y_Dreh) + Y_Dreh;
        Figur[I].X:= ROUND(X0);
        Figur[I].Y:= ROUND(Y0)
      END
END;

PROCEDURE Horiz_Spiegeln(Anzahl: INTEGER; VAR Figur: Matrix);
VAR I: INTEGER;
BEGIN
  FOR I:= 1 TO Anzahl DO
      BEGIN
        Figur[I].X:= -Figur[I].X;
        Figur[I].Y:= Figur[I].Y;
      END
END;

PROCEDURE Transforme_R3_R2(Anzahl: INTEGER; a:Matrix3D; VAR Figur:Matrix);
VAR i : INTEGER;
BEGIN
 For i:=1 TO Anzahl DO
   BEGIN
    Figur[i].x:=TRUNC(a[i].y-a[i].x/2);
    Figur[i].y:=-TRUNC(a[i].z-a[i].x/2);
   END;
END;

PROCEDURE Drehen3D(DZ:PointType3D; x,y,z: INTEGER; VAR P:PointType3D);
VAR P1: PointType3D;
    ax,ay,az : REAL;

BEGIN
 ax:=(x*Pi)/180; ay:=(y*Pi)/180; az:=(z*Pi)/180;

 P1.x:=P.x;
 P1.y:=ROUND((P.y-DZ.y)*cos(ax) - (P.z-DZ.z)*sin(ax) + DZ.y);
 P1.z:=ROUND((P.y-DZ.y)*sin(ax) + (P.z-DZ.z)*cos(ax) + DZ.z);
 P:=P1;

 P1.y:=P.y;
 P1.x:=ROUND((P.x-DZ.x)*cos(ay) - (P.z-DZ.z)*sin(ay) + DZ.x);
 P1.z:=ROUND((P.x-DZ.x)*sin(ay) + (P.z-DZ.z)*cos(ay) + DZ.z);
 P:=P1;

 P1.z:=P.z;
 P1.x:=ROUND((P.x-DZ.x)*cos(az) - (P.y-DZ.y)*sin(az) + DZ.x);
 P1.y:=ROUND((P.x-DZ.x)*sin(az) + (P.y-DZ.y)*cos(az) + DZ.y);
 P:=P1;
END;

END.